code	segment	'code'
	assume	cs:code, ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0			; extra word to hold far jump segment

new21:	cmp	ax,4300h		; check for DOS GetAttributes function
	jne	start			; jump to previous handler if not

	push	ax			; save registers used on stack
	push	cx
	push	si

	mov	si,dx			; search filespec at DS:DX
	mov	cx,255			; maximum length to search
	cld

cloop:	lodsb
	cmp	al,'.'			; check for start of extension
	jne	term

	lodsw				; check if extension is "CDR<nul>"
	cmp	ax,4443h
	jne	done
	lodsw
	cmp	ax,0052h
	jne	done

	pop	si			; restore registers
	pop	cx
	pop	ax

	xor	cx,cx			; no attributes at all
	clc				; clear carry flag, no error
	retf	2

term:	cmp	al,0			; drop out at terminator or max length
	loopne	cloop

done:	pop	si			; restore registers
	pop	cx
	pop	ax
	jmp	start			; jump to previous handler

init:	mov	ax,3521h		; create jump to previous int handler
	int	21h
	mov	byte ptr start,0eah	; opcode for far jump
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new21		; hook into the chain
	mov	ax,2521h
	int	21h

	mov	es,word ptr envseg	; free the environment seg to save memory
	mov	ah,49h
	int	21h

	mov	dx,0014h		; terminate, leaving DX paragraphs resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
